# -*- coding: utf-8 -*-
# Generated by Django 1.10 on 2016-08-22 09:02
from __future__ import unicode_literals

import cq.models
import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='RepeatingTask',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('crontab', models.CharField(default='* * * * *', help_text='Minute Hour Day Month Weekday', max_length=100, validators=[cq.models.validate_cron])),
                ('func_name', models.CharField(max_length=256, validators=[cq.models.validate_func_name])),
                ('args', django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=[])),
                ('kwargs', django.contrib.postgres.fields.jsonb.JSONField(blank=True, default={})),
                ('last_run', models.DateTimeField(blank=True, null=True)),
                ('next_run', models.DateTimeField(blank=True, db_index=True, null=True)),
                ('coalesce', models.BooleanField(default=True)),
                ('result_ttl', models.PositiveIntegerField(blank=True, default=1800)),
            ],
        ),
        migrations.CreateModel(
            name='Task',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('status', models.CharField(choices=[('P', 'Pending'), ('Y', 'Retry'), ('Q', 'Queued'), ('R', 'Running'), ('F', 'Failure'), ('S', 'Success'), ('W', 'Waiting'), ('I', 'Incomplete'), ('L', 'Lost')], db_index=True, default='P', max_length=1)),
                ('signature', django.contrib.postgres.fields.jsonb.JSONField(blank=True, default={})),
                ('details', django.contrib.postgres.fields.jsonb.JSONField(blank=True, default={})),
                ('submitted', models.DateTimeField(auto_now_add=True)),
                ('started', models.DateTimeField(blank=True, null=True)),
                ('parent', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='subtasks', to='cq.Task')),
                ('previous', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='next', to='cq.Task')),
                ('waiting_on', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='cq.Task')),
                ('at_risk', models.CharField(choices=[('N', 'None'), ('Q', 'Queued'), ('R', 'Running')], default='N', max_length=1)),
                ('finished', models.DateTimeField(blank=True, null=True)),
                ('result_expiry', models.DateTimeField(blank=True, null=True)),
                ('result_ttl', models.PositiveIntegerField(blank=True, default=1800)),
            ],
            options={
                'ordering': ('-submitted',),
            },
        ),
    ]
